        list p=16c54, f=inhx8m

rx_buf	equ	8h	; serial input buffer
count8	equ	9h	; brojac za prijem 8 bitova
scratch	equ	0ah	; gp scratchpad

pat_lo	equ	0bh	; patience couner lo byte
pat_nxt	equ	0ch	; patience couner next byte
pat_hi	equ	0dh	; patience couner hi byte

temp_rx	equ	0eh	; privremeni rx izmedju 1. i 2. bajta komande i chs

count4	equ	0fh	; za 256*4=1024 by
count256	equ	10h	; za 256*4=1024 by

     include	     "picreg.equ"

	org	0
pocetak
	goto	over


	org	8
over	goto	start


;;								; rx byte
;Ŀ
; prima jedan bajt sa rs232 preko rtcc u rx_buf, cy set if timeout          
; ne detektuje framing error (ignorise stop bit)                            
; sinhronizuje se na opadajucu ivicu (ne treba detekcija nivoa na ulazu)    
; koristi rxbuf, count8, scratch, pat_*                                     
; mora da bude rte=1 na ulazu                                               
;                                                                          


get_byte				; rx byte from serial port, cy set if timeout
	clrf	rtcc		; clr brojacki reg
				; ...preset patience counter...
	clrf	pat_lo
	clrf	pat_nxt
	movlw	.4		; toliko puta po 91.75 ms
	movwf	pat_hi		; cycles until timeout, za 367 ms

get_start			; ...patience counter service...
	decfsz	pat_lo,same	; 1
	goto	go_test		; 2
	decfsz	pat_nxt,same
	goto	go_test
	decfsz	pat_hi,same
	goto	go_test
	bsf	status,c	; set c: timeout!
	retlw	0
go_test				; ...falling edge detector...
	movf	rtcc,w		; 1  nz if >0
	btfsc	status,z	; 1  skip if nz (if falling edge detected)
	goto	get_start	; 2  loop if rtcc=0, no falling edge detected

				; falling edge detected ---------------------
	movlw	8h		; 8 bits to read
	movwf	count8

	movlw	11h		; 1  waist 53t (za ukupno 1,5 bit)
bits8				; ------------------------------- 8 bits loop
	movwf	scratch		; 1
in_loop
	decfsz	scratch,same	; 1x10=10
	goto	in_loop		; 2x10=20 (total 30-1=29)
	nop			; 1

				;Ŀ
	clrf	rtcc		; brojacki reg
	movlw	28h		; 0101000 x lo
	option			; rte lo      
	nop			; delay       
	movlw	38h		; 0111000 x hi
	rrf	rtcc,same	;           stanje sa rtcc pina u carry
	option			; rte hi      
				; (7t)

	rrf	rx_buf,same	; 1  rotate carry in rx_buf

	movlw	0ah		; 1  prepare to waist 29t in next loop
	decfsz	count8,same	; 1
	goto	bits8		; 2  loop 8x43t      (za 115200 treba 43.4 t)

	bcf	status,c	; clr c: o.k.
	retlw	0
;								; preskakanje
jump1k64
	movlw	.64
	movwf	rx_buf

;Ŀ
; salje preko porta,1 ukupno rx_buf * 1k + 1 impulsa na brojac              
; u sve preskocene lokacije upisuje 0ffh (artefakt)                         
; podrzava slucaj kad je rx_buf=0, onda salje samo 1 impuls                 
; na ulazu porta,1=izlaz=hi, portb=izlazi=0ffh                              
;

jump1k
	movlw	0ffh
	movwf	portb		; port b = 0ffh

	bsf	porta,0		; inside bus
	movlw	0h		; port b: all bits outputs
	tris	portb

	bcf	porta,1		; Ŀ	prvi impuls
	bsf	porta,1		;   

	movf	rx_buf,same
	btfsc	status,z	; skip if nz (if rx_buf > 0)
	retlw	0		; vrati se ako treba 0 preskakanja	

	clrf	scratch		; za 256 * 4 = 1024 impulsa
loop1k
	bcf	porta,1
	bsf	porta,1
	bcf	porta,1		; Ŀڿڿڿڿڿڿڿ
	bsf	porta,1		;   
	bcf	porta,1
	bsf	porta,1
	bcf	porta,1
	bsf	porta,1		; 4x lo-hi
	
	decfsz	scratch,same
	goto	loop1k		; loop 1k (2816t=563.2us)

	decfsz	rx_buf,same
	goto	loop1k		; loop rx*1k (rx*564us)(72.192 ms za 128k)
	
	retlw	0

;								; silence
;Ŀ
; ceka tisinu na serial portu 0.7 s i vraca se                              
;

silence				; ceka tisinu na portu 0.7 s
	clrf	rtcc		; clr brojacki reg
	movlw	.17
	movwf	pat_hi		; za 0.7 s
	clrf	pat_nxt
testsil
	movf	rtcc,same
  	btfss	status,z
	goto	silence		; no silence, test failed: start again
small
	decfsz	pat_lo,same
	goto	small		; 767t (153 us)

	decfsz	pat_nxt,same
	goto	testsil		; 197000t (40 ms)
	
	decfsz	pat_hi,same
	goto	testsil		; 17 testova, 0.7 s
	retlw	0		; pronasao tisinu 0.7 s


;								; start
	org	100h

;Ŀ
; Inicijalizacija  /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\ 
;

start
	movlw	38h		; rte hi
	option

	movlw	0bh
	movwf	porta		; reset=1 a16=0 write=1 mode=1
	movlw	0ffh
	movwf	portb		; port b = 0ffh

	movlw	00h		; port a: all bits outputs
	tris	porta				

	call	jump1k64	; brisanje prvih 64k memorije
	bsf	porta,2		; a16=hi
	call	jump1k64	; brisanje drugih 64k memorije
	bcf	porta,2		; a16=lo

error				; error ept: reset on, wait for silence 0.7 s
	movlw	0ffh
	tris	portb		; port b: all bits inputs
	bcf	porta,0		; outside bus selected

	bsf	porta,3		; reset on
	call	silence		; wait for silence
farm
	call	get_byte	; <----
	btfsc	status,c
	goto	farm		; loop if c set (timeout)

	movf	rx_buf,w
	movwf	temp_rx

	call	get_byte	; <----
	btfsc	status,c
	goto	farm		; loop if c set (timeout)

	comf	rx_buf,same	; drugi bajt komplementiran
	movf	temp_rx,w
	subwf	rx_buf,w	; drugi - prvi --> w
	btfss	status,z
	goto	error		; error if byte1 <> -byte2

	btfsc	rx_buf,7
	goto	error		; error if bit 7 in command set	

	btfsc	rx_buf,6
	goto	com64

;Ŀ
; commands execution                                                        
;                    01 - Reset 0.5 sec                                     
;                    02 - Reset ON                                          
;                    03 - Internal bus selected (portb outputs)             
;                    04 - Extaernal bus selected (portb inputs)             
;                    05 - Reset OFF                                         
;                    06 - spusti A16                                        
;                    07 - podigni A16                                       
;                    08 - izbrisi ceo RAM                                   
;                    09 - primi sledecih 1024 by + chs, error if chs fail   
;                64-127 - preskoci sledecih N-64*1K+1by                     
;

	decfsz	temp_rx,same
	goto	com02

com01				; 01 ept: reset 0.5 sec
	bsf	porta,3		; res on

	movlw	.12		; za 0.5 sec
	movwf	pat_hi
	clrf	pat_nxt
loop1
	decfsz	pat_lo,same
	goto	loop1		; 767t = 154 us
	decfsz	pat_nxt,same
	goto	loop1		; 40 ms
	decfsz	pat_hi,same
	goto	loop1		; 500 ms

	bcf	porta,3		; res off
	goto	farm

com02				; 02 ept: reset on
	decfsz	temp_rx,same
	goto	com03
	bsf	porta,3
	goto	farm

com03				; 03 ept: inside bus selected
	decfsz	temp_rx,same
	goto	com04
	bsf	porta,0
	movlw	0
	tris	portb		; port b: all bits outputs
	goto	farm

com04				; 04 ept: outside bus selected
	decfsz	temp_rx,same
	goto	com05
	movlw	0ffh
	tris	portb		; port b: all bits inputs
	bcf	porta,0
	goto	farm

com05				; 05 ept: reset off
	decfsz	temp_rx,same
	goto	com06
	bcf	porta,3
	goto	farm

com06				; 06 ept: spusti A16
	decfsz	temp_rx,same
	goto	com07
com06b	bcf	porta,2
	goto	farm

com07				; 07 ept: podigni A16
	decfsz	temp_rx,same
	goto	com08
	bsf	porta,2
	goto	farm

com08				; 08 ept: izbrisi ceo RAM
	decfsz	temp_rx,same
	goto	com09
	call	jump1k64	; brisanje prvih 64k
	bsf	porta,2		; a16=hi
	call	jump1k64	; brisanje drugih 64k, pa nastavlja na com06
	goto	com06b

com09				; 09 ept: primi sledecih 1024 by
	decfsz	temp_rx,same
	goto	error		; jer nema vise komandi

	movlw	.4
	movwf	count4		; za 4*256=1024 by
	clrf	count256
loop4b
	clrf	temp_rx		; da bude cisto za chs
loop4
	call	get_byte	; <---- data byte
	btfsc	status,c
	goto	error		; error if c set (timeout)

	movf	rx_buf,w
	movwf	portb		; output data to port b = rx_buf
	addwf	temp_rx,same	; chs update

	bcf	porta,1		; Ŀ	impuls upisa u ram
	bsf	porta,1		;   

	decfsz count256,same	; loop 256 data bytes
	goto	loop4

	call	get_byte	; <---- chs byte (posle svakih 256 data by)
	btfsc	status,c
	goto	error		; error if c set (timeout)

	movf	rx_buf,w
	xorwf	temp_rx,w
	btfss	status,z
	goto	error		; checksum does not match

	decfsz count4,same	; loop 4 * 256 data + 1 chs
	goto	loop4b
	goto	farm

com64				; 64-127 ept
	movlw	3fh
	andwf	rx_buf,same
	call	jump1k
	goto	farm
;								; ept
	org	01ffh
	goto	pocetak

	end
